#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <gd.h>
#include <gdfonts.h>
#include <time.h>

#include "config.h"

int main(int argc, char** argv) {
    int r[4];
    int ena[4];
    char buff[128];
    int f;
    int a[PNGW-MARGINX][4];
    long i,j,start,end;
    struct stat sbuff;
    int s,max,x,y,maxa;
    time_t starttime;
    time_t tm;
    int spp;
    gdImagePtr im;
    int bg,fg,col[4];
    FILE *out;
    im = gdImageCreateTrueColor(PNGW, PNGH);
    bg = gdImageColorResolve(im, 255, 255, 255);
    fg = gdImageColorResolve(im, 0, 0, 0);
    col[0] = gdImageColorResolve(im, 128, 0, 0);
    col[1] = gdImageColorResolve(im, 0, 128, 0);
    col[2] = gdImageColorResolve(im, 0, 0, 128);
    col[3] = gdImageColorResolve(im, 0, 128,128);
    
    if (argc<5) {
	printf("Usage: %s ena1 ena2 ena3 ena4 [from to]\n where enaX=1 to enable and 0 to disable a channel.\n",argv[0]);
	printf("Data will be read from %s and written to %s .\n",DATFILE,PNGOUT);
	exit(0);
    }
    for (x=0; x<4; x++) ena[x]=atoi(argv[x+1]);

    //Open datafile
    f=open(DATFILE,O_RDONLY);
    //Read size
    fstat(f,&sbuff);
    //Handle from & to
    if (argc==7) {
	start=atoi(argv[5]);
	end=atoi(argv[6]);
    } else {
	start=0;
	end=sbuff.st_size/(4*sizeof(int));    
    } 
    starttime=time(NULL)-(sbuff.st_size/(4*sizeof(int)))*INTERVAL;
    //Sanitize start & end
    if (end<=start) end=start+1;
    if (start<0) start=0; if (end<0) end=0;
    if (start>sbuff.st_size/(4*sizeof(int))) start=sbuff.st_size/(4*sizeof(int));
    if (end>sbuff.st_size/(4*sizeof(int))) end=sbuff.st_size/(4*sizeof(int));
    spp=(end-start)/(PNGW-MARGINX)+1;
    if (spp==0) spp=1;
#ifdef DEBUG
    printf("Size: %i; spp: %i\n",sbuff.st_size,spp);
#endif
    starttime=time(NULL)-INTERVAL*(sbuff.st_size/(4*sizeof(int)));

    for (i=0; i<PNGW-MARGINX; i++) {
	for (j=0; j<4; j++) {
	     a[i][j]=0;
	}
    }

    i=0;
    while(read(f,r,sizeof(int)*4)>0) {
	if ((i>start) && (i<end)) {
	    for (j=0; j<4; j++) {
		a[(int)((float)(i-start)/spp)][j]+=r[j];
	    }
	}
	i++;
    }
    maxa=((i<end?i:end)-start)/spp;

#ifdef DEBUG
    printf("Samples read & averaged.\n");
#endif

    
    max=1;
    for (i=0; i<(PNGW-MARGINX); i++) {
	for (j=0; j<4; j++) {
	    if (ena[j])
	     if (a[i][j]>max) max=a[i][j];
	}
    }
#ifdef DEBUG
    printf("Max: %i\n",max);
#endif


    gdImageFilledRectangle(im,0,0,PNGW,PNGH,bg);
    for (j=0; j<4; j++) {
	if (ena[j]) {
	    gdImageSetAntiAliased(im, col[j]);
	    for (i=1; i<(PNGW-MARGINX); i++) {
		//gdImageSetPixel(im,i+MARGINX,(PNGH-MARGINY-1)-((a[i][j]*(PNGH-MARGINY-5))/max),col[j]);
		gdImageLine(im,(i+MARGINX-1),(PNGH-MARGINY-1)-((a[i-1][j]*(PNGH-MARGINY-5))/max),\
		 (i+MARGINX),(PNGH-MARGINY-1)-((a[i][j]*(PNGH-MARGINY-5))/max),
		 gdAntiAliased);
	    }
	}
    }

    tm=starttime+(start*INTERVAL);
    strftime(buff,255,"%x %X",localtime(&tm));
    gdImageString(im,gdFontSmall,MARGINX+2,PNGH-MARGINY+1,buff,fg);
    tm=starttime+(end*INTERVAL);
    strftime(buff,255,"%x %X",localtime(&tm));
    if (maxa>PNGW-MARGINX-(strlen(buff)*gdFontSmall->w)) maxa=PNGW-MARGINX-(strlen(buff)*gdFontSmall->w);
    if (maxa<(strlen(buff)*gdFontSmall->w)+10) maxa=(strlen(buff)*gdFontSmall->w)+10;
    gdImageString(im,gdFontSmall,(maxa+MARGINX),PNGH-MARGINY+1,buff,fg);
    sprintf(buff,"%i",max);
    gdImageString(im,gdFontSmall,0,0,buff,fg);

//    buff[strftime(buff,15,"%i",max)]=0;;
//    gdImageString(im,gdFontSmall,0,0,buff,fg);
    gdImageLine(im,0,PNGH-MARGINY,PNGW,PNGH-MARGINY,fg);
    gdImageLine(im,MARGINX,0,MARGINX,PNGH,fg);
#ifdef DEBUG
    printf("Writing to %s\n",PNGOUT);
#endif
    printf("Limits: %i %i %i\n",start,end,maxa);
    out=fopen(PNGOUT,"w");
    gdImagePng(im,out);
    fclose(out);
}
